# NUCLEO-WB55RG Nucleo-64 board

## Overview

The NUCLEO-WB55RG STM32WB Nucleo-64 board is Bluetooth® Low Energy (BLE) wireless and ultra-low-power device embedding a powerful and ultra-low-power radio compliant with the Bluetooth® Low Energy (BLE) SIG specification v5.2. NUCLEO-WB55RG also offers a radio compliant with IEEE 802.15.4-2011 standard and allows the simple and quick evaluation of STM32WB55xx and STM32WB35xx devices.

The STM32 Nucleo-64 board does not require any separate probe as it integrates the ST-LINK debugger/programmer.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um1727-getting-started-with-stm32-nucleo-board-software-development-tools-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32WB55RG microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32wb55rg.html)
- [NUCLEO-WB55RG board](https://www.st.com/en/evaluation-tools/nucleo-wb55rg.html)
- [User manual](https://www.st.com/resource/en/user_manual/um1727-getting-started-with-stm32-nucleo-board-software-development-tools-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/nucleo-wb55rg.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1355-wb55rg-d01_schematic.pdf)
